package io.tswf.minecraft.blockventure.modloader.compat.metamorphosis

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import groovy.transform.Memoized
import io.tswf.minecraft.blockventure.modloader.scanner.ModsScanner
import io.tswf.minecraft.metamorphosis.core.scanning.IFilesToScanProvider

@AutoService(IFilesToScanProvider)
@CompileStatic
class ModFilesToScanProvider implements IFilesToScanProvider {

    @Memoized
    @Override
    List<File> getFilesToScan() {
        return ModsScanner.scanMods()
            .map { it.runtimeMeta.fileFromRead }
    }
}
