package io.tswf.minecraft.blockventure.modloader.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.modloader.meta.ModMetadata

@CompileStatic
class DuplicatedModIdException extends RuntimeException {
    List<ModMetadata> conflicts

    DuplicatedModIdException(List<ModMetadata> conflicts) {
        super("Therer is conflicting mods found: ${ conflicts.map { "${it.id}-${it.version}: located in ${ it.runtimeMeta?.fileFromRead?.absoluteCanonicalFile?.path }" } }")
        this.conflicts = conflicts
    }
}
