package io.tswf.minecraft.blockventure.modloader.exception

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.modloader.scanner.IModFileCandidatesProvider

@CompileStatic
class ModCandidateFilesProviderException extends RuntimeException {
    IModFileCandidatesProvider provider

    ModCandidateFilesProviderException(IModFileCandidatesProvider provider) {
        super(getExceptionMessage(provider))
        this.provider = provider
    }

    ModCandidateFilesProviderException(String message, IModFileCandidatesProvider provider) {
        super(getExceptionMessage(provider, message))
        this.provider = provider
    }

    ModCandidateFilesProviderException(String message, Throwable cause, IModFileCandidatesProvider provider) {
        super(getExceptionMessage(provider, message), cause)
        this.provider = provider
    }

    ModCandidateFilesProviderException(Throwable cause, IModFileCandidatesProvider provider) {
        super(getExceptionMessage(provider), cause)
        this.provider = provider
    }

    static String getExceptionMessage(IModFileCandidatesProvider provider, String message = "") {
        return "Exception occurred while trying to provide mod candidate files by ${provider}: ${message}"
    }
}
