package io.tswf.minecraft.blockventure.modloader.exception

import groovy.transform.CompileStatic

@CompileStatic
class ModFileScanException extends RuntimeException {
    File modFile

    ModFileScanException(File modFile) {
        super(getExceptionMessage(modFile))
        this.modFile = modFile
    }

    ModFileScanException(String message, File modFile) {
        super(getExceptionMessage(modFile, message))
        this.modFile = modFile
    }

    ModFileScanException(String message, Throwable cause, File modFile) {
        super(getExceptionMessage(modFile, message), cause)
        this.modFile = modFile
    }

    ModFileScanException(Throwable cause, File modFile) {
        super(getExceptionMessage(modFile), cause)
        this.modFile = modFile
    }

    static String getExceptionMessage(File modFile, String message = "") {
        return "Exception occurred while trying to read mod file '${modFile.absoluteCanonicalFile.path}': ${message}"
    }
}
