package io.tswf.minecraft.blockventure.modloader.meta

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode

@CheckedMapConstructor
@CompileStatic
class ModMetadata {
    String id
    String name
    String description
    List<String> authors
    String version

    transient ModRuntimeMetadata runtimeMeta

    String toShortString() {
        return "id: '${id}', version '${version}', located in ${runtimeMeta?.fileFromRead?.absoluteCanonicalFile?.path}"
    }
}

@CheckedMapConstructor
@CompileStatic
class ModRuntimeMetadata {
    ClassNode modClassNode
    File fileFromRead
    Class modClass = null
    Object modInstance = null
    ModStatus status = ModStatus.SCANNED
}

enum ModStatus {
    SCANNED,
    CREATED,
    INITIALIZED
}