package io.tswf.minecraft.blockventure.modloader.scanner

import groovy.transform.CompileStatic
import groovy.transform.Memoized

@CompileStatic
class ModsFolderScanner {

    public static final String MODS_FOLDER_MARKER_FILE = ".there-is-block-venture-mods"

    @Memoized
    static List<File> scanModFolders() {
        return new File("./")
            .listFiles()
                ?.stream()
                    ?.filter { it.isDirectory() && it.subFile(MODS_FOLDER_MARKER_FILE).exists() }
                    ?.toList()
                ?: []
    }
}
