package io.tswf.minecraft.blockventure.modloader.scanner.provider

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.modloader.scanner.IModFileCandidatesProvider
import io.tswf.minecraft.blockventure.modloader.scanner.ModsFolderScanner

@AutoService(IModFileCandidatesProvider)
@CompileStatic
class BlockventureModsFolderModFileCandidatesProvider implements IModFileCandidatesProvider {

    @Override
    List<File> getModsFiles() {
        def modFolders = ModsFolderScanner.scanModFolders()
        def result = modFolders.stream()
            .flatMap {modsFolder ->
                modsFolder.walkSubFiles()
                    .filter { it.nameExtension == "jar" }
            }
            .toList()

        return result
    }
}
