package io.tswf.minecraft.blockventure.modloader.scanner.provider

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.modloader.scanner.IModFileCandidatesProvider

@AutoService(IModFileCandidatesProvider)
@CompileStatic
class ClasspathModFileCandidatesProvider implements IModFileCandidatesProvider {

    @Override
    List<File> getModsFiles() {
        def result = System.classpathList.stream()
            .filter { it.protocol == "file" }
            .map { new File(it.path) }
            .toList()

        return result
    }
}
